from logging.config import fileConfig

from flask import current_app as app

from sqlalchemy import engine_from_config
from sqlalchemy import pool

from alembic import context

#
# Modified for SnapTravel connectivity demo.
#
from api.create_flask_application import create_app
from api.core import db

# this is the Alembic Config object, which provides
# access to the values within the .ini file in use.
config = context.config

# Interpret the config file for Python logging.
# This line sets up loggers basically.
fileConfig(config.config_file_name)

# add your model's MetaData object here
# for 'autogenerate' support
# from myapp import mymodel
# target_metadata = mymodel.Base.metadata
target_metadata = db.Model.metadata

# other values from the config, defined by the needs of env.py,
# can be acquired:
# my_important_option = config.get_main_option("my_important_option")
# ... etc.


def run_migrations_offline():
    """Run migrations in 'offline' mode.

    This configures the context with just a URL
    and not an Engine, though an Engine is acceptable
    here as well.  By skipping the Engine creation
    we don't even need a DBAPI to be available.

    Calls to context.execute() here emit the given string to the
    script output.

    """
    #url = config.get_main_option("sqlalchemy.url")
    url = app.config['SQLALCHEMY_DATABASE_URI']
    context.configure(
        url=url,
        target_metadata=target_metadata,
        literal_binds=True,
        dialect_opts={"paramstyle": "named"},
    )

    with context.begin_transaction():
        context.run_migrations()


def __autogenerated_run_migrations_online():
    """Run migrations in 'online' mode.

    In this scenario we need to create an Engine
    and associate a connection with the context.

    """
    engine = db.engine
    connection = engine.connect()
    connectable = engine_from_config(
        config.get_section(config.config_ini_section),
        prefix="sqlalchemy.",
        poolclass=pool.NullPool,
    )

    with connectable.connect() as connection:
        context.configure(
            connection=connection, target_metadata=target_metadata
        )

        with context.begin_transaction():
            context.run_migrations()

def run_migrations_online():
    """
    Run migrations in 'online' mode.

    In this scenario we need to create an Engine
    and associate a connection with the context.
    """
    with create_app().test_request_context():
        engine = db.engine

        connection = engine.connect()
        #
        # Modified for SnapTravel connectivity demo.
        #
        alembic_config = config.get_section(config.config_ini_section)
        alembic_config['sqlalchemy.url'] = \
            app.config['SQLALCHEMY_DATABASE_URI']
        engine = engine_from_config(
            alembic_config, prefix='sqlalchemy.', poolclass=pool.NullPool)
        context.configure(connection=connection,
                          target_metadata=target_metadata,
                          compare_type=True)

        try:
            with context.begin_transaction():
                context.run_migrations()
        finally:
            connection.close()

if context.is_offline_mode():
    run_migrations_offline()
else:
    run_migrations_online()
